﻿
namespace PH.Bootloader.RS485
{
    /// <summary>列舉所有啟動程序安裝結果。</summary>
    public enum BootloadResult : int
    {
        /// <summary>通訊埠備妥。</summary>
        SerialPortReady         = 0,
        /// <summary>通訊埠尚未備妥。</summary>
        SerialPortNotReady,
        /// <summary>未偵測到裝置。</summary>
        DetectNothing           = 10,
        /// <summary>偵測裝置失敗。</summary>
        DetectFailed,
        /// <summary>偵測到裝置。</summary>
        DetectDevice,
        /// <summary>映像檔備妥。</summary>
        ImageFileReady          = 20,
        /// <summary>不合適的映像檔。</summary>
        ImageFileNotAppCode,
        /// <summary>映像檔不存在。</summary>
        ImageFileNotExist,
        /// <summary>映像檔跟裝置不匹配。</summary>
        ImageFileNotMatch,
        /// <summary>記憶體配置完成。</summary>
        MemoryAllocationReady,
        /// <summary>記憶體配置失敗。</summary>
        MemoryAllocationFailed,
        /// <summary>記憶體已抹除。</summary>
        FlashErased,
        /// <summary>記憶體抹除失敗。</summary>
        EraseFlashFailed,
        /// <summary>上載成功。</summary>
        Uploaded                = 40,
        /// <summary>上載失敗。</summary>
        UploadFailed,
        /// <summary>有其他程序執行中。</summary>
        HasOthersProcessRunning = 50
    }
}
