﻿using Net.Core.Communication.Serial.Sync;

namespace PH.Bootloader.RS485.Communication
{
    /// <summary>同步式(整合單獨收發)串列埠處理類別。</summary>
    public class SerialPortHandler : SyncCommProvider, ISyncCommunicationPlus
    {
        /// <summary>初始化 SerialPortHandler 類別的新執行個體。</summary>
        /// <param name="syncTime"></param>
        public SerialPortHandler() : base() {}

        /// <summary>初始化 SerialPortHandler 類別的新執行個體。</summary>
        /// <param name="syncTime"></param>
        public SerialPortHandler(int syncTime) : base(syncTime) {}

        /// <summary>位元組接收。</summary>
        /// <returns>是否接收到。</returns>
        public bool ReadByte(out byte data)
        {
            data = 0x00;

            /*if (serialPort.BytesToRead > 0)
            {
                data = (byte)serialPort.ReadByte();
                return true;
            }*/

            try
            {
                data = (byte)serialPort.ReadByte();
                return true;
            }
            catch
            {
                return false;
            } 
        }

        /// <summary>讀取一個位元組。</summary>
        /// <returns>接收位元組。</returns>
        public byte ReadByte()
        {
            return (byte)serialPort.ReadByte();
        }

        /// <summary>資料傳送。</summary>
        /// <param name="txBuffer">傳送資料暫存器。</param>
        /// <param name="txLength">傳送資料長度。</param>
        public void Send(byte[] txBuffer, int txLength)
        {
            if (serialPort.IsOpen)
            {
                serialPort.Write(txBuffer, 0, txLength);
            }
        }
    }
}
