﻿using System;

namespace PH.Bootloader.RS485.DSP.Procedure
{
    /// <summary>封裝寫入記憶體區塊資訊之類別</summary>
    class MemoryBlockContent
    {
        /// <summary>取得、設定記憶體位置。</summary>
        public long     Address { get; set; }
        /// <summary>取得、設定資料陣列。</summary>
        public byte[]   DataArray { get; set; }

        /// <summary>初始化 MemoryBlockContent 類別的新執行個體。</summary>
        /// <param name="dataLength"></param>
        public MemoryBlockContent(int dataLength)
        {
            DataArray = new byte[dataLength];
        }

        /// <summary>合併資料內容成位元組陣列。</summary>
        /// <returns></returns>
        public byte[] Merge()
        {
            byte[] outcome = new byte[4+ DataArray.Length];
            outcome[0] = (byte)Address;
            outcome[1] = (byte)(Address >> 8);
            outcome[2] = (byte)(Address >> 16);
            outcome[3] = (byte)(Address >> 24);
            Array.Copy(DataArray, 0, outcome, 4, DataArray.Length);
            return outcome;
        }
    }
}
