﻿using System.Collections.Generic;

namespace PH.Bootloader.RS485.DSP.Protocol
{
    /// <summary>封裝所有接收封包內容於類別中。這個類別無法被繼承。</summary>
    class ReceivedPacketContent
    {
        /// <summary>檔頭。</summary>
        public byte         Header {get; set;}
        /// <summary>封包來源。</summary>
        public byte         Source { get; set; }
        /// <summary>封包目的。</summary>
        public byte         Destination { get; set; }
        /// <summary>資料長度。</summary>
        public byte         DataLength { get; set; }
        /// <summary>>對暫存器動作。</summary>
        public Command      Command { get; set; }
        /// <summary>資料載荷。</summary>
        public List<byte>   Payload { get; set; } 
        /// <summary>計算的CRC數值。</summary>
        public int          CalculatedCRC { get; set; }
        /// <summary>接收的CRC數值。</summary>
        public int          ReceivedCRC { get; set; }

        /// <summary>初始化 ReceivedPacketContent 類別的新執行個體。</summary>
        public ReceivedPacketContent()
        {
            Payload = new List<byte>();
        }
    }
}
