﻿using System.Collections.Generic;

namespace PH.Bootloader.RS485.PIC32_2
{
    /// <summary>封裝所有裝置資訊之類別。</summary>
    public class DeviceInformation
    {
        /// <summary>C1P1。</summary>
        public static DeviceInformation C1P1 = new DeviceInformation(DeviceType.PSU, 0xE0E0, "C1-P1");
        /// <summary>C1P2。 </summary>
        public static DeviceInformation C1P2 = new DeviceInformation(DeviceType.PSU, 0xE1E1, "C1-P2");
        /// <summary>C1P3。 </summary>
        public static DeviceInformation C1P3 = new DeviceInformation(DeviceType.PSU, 0xE2E2, "C1-P3");
        /// <summary>C1P4。 </summary>
        public static DeviceInformation C1P4 = new DeviceInformation(DeviceType.PSU, 0xE3E3, "C1-P4");
        /// <summary>C1P5。 </summary>
        public static DeviceInformation C1P5 = new DeviceInformation(DeviceType.PSU, 0xE4E4, "C1-P5");
        /// <summary>C1P6。 </summary>
        public static DeviceInformation C1P6 = new DeviceInformation(DeviceType.PSU, 0xE5E5, "C1-P6");
        /// <summary>C1P7。 </summary>
        public static DeviceInformation C1P7 = new DeviceInformation(DeviceType.PSU, 0xE6E6, "C1-P7");
        /// <summary>C1P8。 </summary>
        public static DeviceInformation C1P8 = new DeviceInformation(DeviceType.PSU, 0xE7E7, "C1-P8");
        /// <summary>C2P1。 </summary>
        public static DeviceInformation C2P1 = new DeviceInformation(DeviceType.PSU, 0xE8E8, "C2-P1");
        /// <summary>C2P2。 </summary>
        public static DeviceInformation C2P2 = new DeviceInformation(DeviceType.PSU, 0xE9E9, "C2-P2");
        /// <summary>C2P3。 </summary>
        public static DeviceInformation C2P3 = new DeviceInformation(DeviceType.PSU, 0xEAEA, "C2-P3");
        /// <summary>C2P4。 </summary>
        public static DeviceInformation C2P4 = new DeviceInformation(DeviceType.PSU, 0xEBEB, "C2-P4");
        /// <summary>C2P5。 </summary>
        public static DeviceInformation C2P5 = new DeviceInformation(DeviceType.PSU, 0xECEC, "C2-P5");
        /// <summary>C2P6。 </summary>
        public static DeviceInformation C2P6 = new DeviceInformation(DeviceType.PSU, 0xEDED, "C2-P6");
        /// <summary>C2P7。 </summary>
        public static DeviceInformation C2P7 = new DeviceInformation(DeviceType.PSU, 0xEEEE, "C2-P7");
        /// <summary>C2P8。 </summary>
        public static DeviceInformation C2P8 = new DeviceInformation(DeviceType.PSU, 0xEFEF, "C2-P8");
        /// <summary>C3P1。</summary>
        public static DeviceInformation C3P1 = new DeviceInformation(DeviceType.PSU, 0xC0C0, "C3-P1");
        /// <summary>C3P2。 </summary>
        public static DeviceInformation C3P2 = new DeviceInformation(DeviceType.PSU, 0xC1C1, "C3-P2");
        /// <summary>C3P3。 </summary>
        public static DeviceInformation C3P3 = new DeviceInformation(DeviceType.PSU, 0xC2C2, "C3-P3");
        /// <summary>C3P4。 </summary>
        public static DeviceInformation C3P4 = new DeviceInformation(DeviceType.PSU, 0xC3C3, "C3-P4");
        /// <summary>C3P5。 </summary>
        public static DeviceInformation C3P5 = new DeviceInformation(DeviceType.PSU, 0xC4C4, "C3-P5");
        /// <summary>C3P6。 </summary>
        public static DeviceInformation C3P6 = new DeviceInformation(DeviceType.PSU, 0xC5C5, "C3-P6");
        /// <summary>C3P7。 </summary>
        public static DeviceInformation C3P7 = new DeviceInformation(DeviceType.PSU, 0xC6C6, "C3-P7");
        /// <summary>C3P8。 </summary>
        public static DeviceInformation C3P8 = new DeviceInformation(DeviceType.PSU, 0xC7C7, "C3-P8");
        /// <summary>C4P1。 </summary>
        public static DeviceInformation C4P1 = new DeviceInformation(DeviceType.PSU, 0xC8C8, "C4-P1");
        /// <summary>C4P2。 </summary>
        public static DeviceInformation C4P2 = new DeviceInformation(DeviceType.PSU, 0xC9C9, "C4-P2");
        /// <summary>C4P3。 </summary>
        public static DeviceInformation C4P3 = new DeviceInformation(DeviceType.PSU, 0xCACA, "C4-P3");
        /// <summary>C4P4。 </summary>
        public static DeviceInformation C4P4 = new DeviceInformation(DeviceType.PSU, 0xCBCB, "C4-P4");
        /// <summary>C4P5。 </summary>
        public static DeviceInformation C4P5 = new DeviceInformation(DeviceType.PSU, 0xCCCC, "C4-P5");
        /// <summary>C4P6。 </summary>
        public static DeviceInformation C4P6 = new DeviceInformation(DeviceType.PSU, 0xCDCD, "C4-P6");
        /// <summary>C4P7。 </summary>
        public static DeviceInformation C4P7 = new DeviceInformation(DeviceType.PSU, 0xCECE, "C4-P7");
        /// <summary>C4P8。 </summary>
        public static DeviceInformation C4P8 = new DeviceInformation(DeviceType.PSU, 0xCFCF, "C4-P8");
        /// <summary>C4P8。 </summary>
        public static DeviceInformation PSU_Broadcast = new DeviceInformation(DeviceType.PSU, 0xFEFE, "PSU-Broadcast");
        /// <summary>PFC1。 </summary>
        public static DeviceInformation PFC1 = new DeviceInformation(DeviceType.PFC, 0xA0A0, "PFC-1");
        /// <summary>PFC2。 </summary>
        public static DeviceInformation PFC2 = new DeviceInformation(DeviceType.PFC, 0xA1A1, "PFC-2");
        /// <summary>PFC3。 </summary>
        public static DeviceInformation PFC3 = new DeviceInformation(DeviceType.PFC, 0xA2A2, "PFC-3");
        /// <summary>PFC4。 </summary>
        public static DeviceInformation PFC4 = new DeviceInformation(DeviceType.PFC, 0xA3A3, "PFC-4");
        /// <summary>PFC5。 </summary>
        public static DeviceInformation PFC5 = new DeviceInformation(DeviceType.PFC, 0xA4A4, "PFC-5");
        /// <summary>PFC6。 </summary>
        public static DeviceInformation PFC6 = new DeviceInformation(DeviceType.PFC, 0xA5A5, "PFC-6");
        /// <summary>PFC7。 </summary>
        public static DeviceInformation PFC7 = new DeviceInformation(DeviceType.PFC, 0xA6A6, "PFC-7");
        /// <summary>PFC8。 </summary>
        public static DeviceInformation PFC8 = new DeviceInformation(DeviceType.PFC, 0xA7A7, "PFC-8");
        /// <summary>C4P8。 </summary>
        public static DeviceInformation PFC_Broadcast = new DeviceInformation(DeviceType.PFC, 0xFEFE, "PFC-Broadcast");
        /// <summary>PSU1。</summary>
        public static DeviceInformation SBOX = new DeviceInformation(DeviceType.SBox, 0x5656, "SBox");
        /// <summary>CSU1。</summary>
        public static DeviceInformation CSU1 = new DeviceInformation(DeviceType.CSU, 0x2020, "CSU-1");
        /// <summary>CSU2。</summary>
        public static DeviceInformation CSU2 = new DeviceInformation(DeviceType.CSU, 0x2121, "CSU-2");
        /// <summary>CSU3。</summary>
        public static DeviceInformation CSU3 = new DeviceInformation(DeviceType.CSU, 0x2222, "CSU-3");
        /// <summary>CSU4。</summary>
        public static DeviceInformation CSU4 = new DeviceInformation(DeviceType.CSU, 0x2323, "CSU-4");
        /// <summary>CSU Broadcast。</summary>
        public static DeviceInformation CSU_Broadcast = new DeviceInformation(DeviceType.CSU, 0x2F2F, "CSU-Broadcast");

        #region Properties
        /// <summary>取得CanBus編號。</summary>
        public byte         CanBusID { get; private set; }
        /// <summary>取得對應的 DSP 編號。</summary>
        public byte         CorrespondDspID { get; private set; }
        /// <summary>取得文字描述。</summary>
        public string       Name { get; private set; }
        /// <summary>取得 RS-485 編號。</summary>
        public byte         RS485ID { get; private set; }
        /// <summary>取得裝置型態。</summary>
        public DeviceType   Type { get; private set; }
        #endregion

        #region Constructor
        /// <summary>初始化 DeviceInformation 類別的新執行個體。</summary>
        /// <param name="type"></param>
        /// <param name="deviceID"></param>
        /// <param name="name"></param>
        public DeviceInformation(DeviceType type, int deviceID, string name)
        {
            CanBusID = (byte)(deviceID & 0xff);
            Name = name;
            RS485ID = (byte)(deviceID >> 8);
            Type = type;
        }
        #endregion

        #region Methods
        /// <summary>取得所有裝置定義。</summary>
        /// <returns></returns>
        public static IEnumerable<DeviceInformation> List
        {
            get
            {
                yield return C1P1;
                yield return C1P2;
                yield return C1P3;
                yield return C1P4;
                yield return C1P5;
                yield return C1P6;
                yield return C1P7;
                yield return C1P8;
                yield return C2P1;
                yield return C2P2;
                yield return C2P3;
                yield return C2P4;
                yield return C2P5;
                yield return C2P6;
                yield return C2P7;
                yield return C2P8;
                yield return C3P1;
                yield return C3P2;
                yield return C3P3;
                yield return C3P4;
                yield return C3P5;
                yield return C3P6;
                yield return C3P7;
                yield return C3P8;
                yield return C4P1;
                yield return C4P2;
                yield return C4P3;
                yield return C4P4;
                yield return C4P5;
                yield return C4P6;
                yield return C4P7;
                yield return C4P8;
                yield return PFC1;
                yield return PFC2;
                yield return PFC3;
                yield return PFC4;
                yield return PFC5;
                yield return PFC6;
                yield return PFC7;
                yield return PFC8;
                yield return SBOX;
                yield return CSU1;
                yield return CSU2;
                yield return CSU3;
                yield return CSU4;
                yield return CSU_Broadcast;
            }
        }

        /// <summary>取得所有裝置定義名稱。</summary>
        /// <returns></returns>
        public static IEnumerable<string> ListDeviceName
        {
            get
            {
                yield return C1P1.Name;
                yield return C1P2.Name;
                yield return C1P3.Name;
                yield return C1P4.Name;
                yield return C1P5.Name;
                yield return C1P6.Name;
                yield return C1P7.Name;
                yield return C1P8.Name;
                yield return C2P1.Name;
                yield return C2P2.Name;
                yield return C2P3.Name;
                yield return C2P4.Name;
                yield return C2P5.Name;
                yield return C2P6.Name;
                yield return C2P7.Name;
                yield return C2P8.Name;
                yield return C3P1.Name;
                yield return C3P2.Name;
                yield return C3P3.Name;
                yield return C3P4.Name;
                yield return C3P5.Name;
                yield return C3P6.Name;
                yield return C3P7.Name;
                yield return C3P8.Name;
                yield return C4P1.Name;
                yield return C4P2.Name;
                yield return C4P3.Name;
                yield return C4P4.Name;
                yield return C4P5.Name;
                yield return C4P6.Name;
                yield return C4P7.Name;
                yield return C4P8.Name;
                yield return PFC1.Name;
                yield return PFC2.Name;
                yield return PFC3.Name;
                yield return PFC4.Name;
                yield return PFC5.Name;
                yield return PFC6.Name;
                yield return PFC7.Name;
                yield return PFC8.Name;
                yield return SBOX.Name;
                yield return CSU1.Name;
                yield return CSU2.Name;
                yield return CSU3.Name;
                yield return CSU4.Name;
                yield return CSU_Broadcast.Name;
            }
        }

        /// <summary>根據名稱，解析出 PSU 通訊位址(站號)定義物件。</summary>
        /// <param name="deviceType"></param>
        /// <returns></returns>
        public static string[] SpecifiedDeviceNames(DeviceType deviceType)
        {
            List<string> outcome = new List<string>();

            foreach (DeviceInformation device in List)
            {
                if (device.Type.Index == deviceType.Index)
                {
                    outcome.Add(device.Name);
                }
            }

            return outcome.ToArray();
        }

        /// <summary>根據 RS-485 站號，解析出 PSU 通訊位址(站號)定義物件。</summary>
        /// <param name="rs485ID"></param>
        /// <returns></returns>
        public static DeviceInformation ParseBy485ID(byte rs485ID)
        {
            foreach (DeviceInformation device in List)
            {
                if (device.RS485ID == rs485ID) {
                    return device;
                }
            }

            return null;
        }
        
        /// <summary>根據名稱，解析出 PSU 通訊位址(站號)定義物件。</summary>
        /// <param name="rs485ID"></param>
        /// <returns></returns>
        public static DeviceInformation ParseByName(string name)
        {
            foreach (DeviceInformation device in List)
            {
                if (device.Name == name) {
                    return device;
                }
            }

            return null;
        }
        #endregion
    }
}
