﻿
namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.AppCode
{
    /// <summary>封裝應用程式碼 (Aplication Code) 指令格式基底類別。</summary>
    abstract class AppCommandFormatter : IAppCommand
    {
        /// <summary>取得、設定位址。</summary>
        public int          Address { get; protected set; }
        /// <summary>取得、設定函式型態。</summary>
        public FunctionType FunctionType { get; protected set; }
        /// <summary>取得、設定數值。</summary>
        public int          Quantity { get; protected set; }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public abstract bool Parse(byte[] recvDataArray, int recvLength);
    }
}
