﻿
namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.AppCode
{
    /// <summary>應用程式碼指令介面。</summary>
    interface IAppCommand
    {
        /// <summary>取得位址。</summary>
        int             Address { get; }
        /// <summary>取得函式型態。</summary>
        FunctionType    FunctionType { get; }
        /// <summary>取得數值。</summary>
        int             Quantity { get; }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        bool Parse(byte[] recvDataArray, int recvLength);
    }
}
