﻿
namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.AppCode
{
    /// <summary>封裝讀取版本號指令之類別。</summary>
    class ReadVersionCmd : AppCommandFormatter
    {
        /// <summary>取得、設定 Bootloader 版本號。</summary>
        public string   Version { get; set; }

        /// <summary>初始化 ReadVersionCmd 類別之執行個體。</summary>
        public ReadVersionCmd()
        {
            Address = 0x5800;
            FunctionType = FunctionType.Read;
            Quantity = 0x0001;
        }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public override bool Parse(byte[] recvDataArray, int length)
        {
            try
            {
                Version = string.Format("{0}.{1:D2}", recvDataArray[5], recvDataArray[6]);
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
