﻿
namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.AppCode
{
    /// <summary>致能應用程式碼更新之指令類別。</summary>
    class UpgradeAppCmd : AppCommandFormatter
    {
        /// <summary>初始化 UpgradeAppCmd 類別之執行個體。</summary>
        public UpgradeAppCmd()
        {
            Address = 0x018F;
            FunctionType = FunctionType.Write;
            Quantity = 0xFF00;
        }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public override bool Parse(byte[] recvDataArray, int length)
        {
            // 偷懶......
            return (length == 10 &&
                    recvDataArray[0] == 0xF0 &&
                    recvDataArray[1] == 0x10 &&
                    //recvDataArray[2] == 0xE0 &&
                    recvDataArray[3] == 0x05 &&
                    recvDataArray[4] == 0x01 &&
                    recvDataArray[5] == 0x8F &&
                    recvDataArray[6] == 0xFF &&
                    recvDataArray[7] == 0x00);
                    //recvDataArray[8] == 0xF5 &&
                    //recvDataArray[9] == 0x09);
        }
    }
}
