﻿
namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.BootCode
{
    /// <summary>封裝啟動程式碼指令格式之基底類別。</summary>
    abstract class BootCommandFormatter : IBootCommand
    {
        /// <summary>取得、設定代碼。</summary>
        public byte Code { get; protected set; }
        /// <summary>取得、設定預計回傳封包長度。</summary>
        public byte EstimateAckLength { get; protected set; } = 1;

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public abstract bool Parse(byte[] recvDataArray, int recvLength);
    }
}
