﻿using System.Windows.Forms;

namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.BootCode
{
    /// <summary>封裝 Erase 指令之類別。</summary>
    class EraseCmd : BootCommandFormatter
    {
        /// <summary>清除完成回傳代碼。</summary>
        public static byte  ERASE_DONE = 0x4B;

        /// <summary>取得清除頁數。</summary>
        public int          Page { get; internal set; }

        /// <summary>初始化 EraseCmd 類別之執行個體。</summary>
        public EraseCmd()
        {
            Code = 0x45;
        }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public override bool Parse(byte[] recvDataArray, int recvLength)
        {
            try
            {
                Page = recvDataArray[0];
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
