﻿using PH.Bootloader.RS485.PIC32_2.Protocol.Command.BootCode;

namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command
{
    /// <summary>封裝 FlashCopyCmd 指令之類別。</summary>
    class FlashCopyCmd : BootCommandFormatter
    {
        /// <summary>複製指令回傳碼。</summary>
        public static byte  ACK         = 0x4B;
        /// <summary>複製完成回傳碼。</summary>
        public static byte  COPY_DONE   = 0x4B;

        /// <summary>取得回傳值。</summary>
        public int          Page { get; internal set; }

        /// <summary>初始化 FlashCopyCmd 類別之執行個體。</summary>
        public FlashCopyCmd()
        {
            Code = 0x50;
        }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public override bool Parse(byte[] recvDataArray, int recvLength)
        {
            try
            {
                Page = recvDataArray[0];
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
