﻿
namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command.BootCode
{
    /// <summary>啟動程式碼指令格式之介面。</summary>
    interface IBootCommand
    {
        /// <summary>取得代碼。</summary>
        byte    Code { get; }
        /// <summary>取得預計回傳封包長度。</summary>
        byte    EstimateAckLength { get; }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        bool Parse(byte[] recvDataArray, int recvLength);
    }
}
