﻿using PH.Bootloader.RS485.PIC32_2.Protocol.Command.BootCode;

namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command
{
    /// <summary>觸發裝置之指令類別。</summary>
    class TriggerCmd : BootCommandFormatter
    {
        /// <summary>觸發裝置回傳代碼1。</summary>
        public static byte  ACK1 = 0xD6;
        /// <summary>觸發裝置回傳代碼2。</summary>
        public static byte  ACK2 = 0x4B;

        /// <summary>取得回傳值1。</summary>
        public byte         Ack1 { get; internal set; }
        /// <summary>取得回傳值2。</summary>
        public byte         Ack2 { get; internal set; }

        /// <summary>初始化 TriggerCmd 類別之執行個體。</summary>
        public TriggerCmd()
        {
            Code = 0xC1;
            EstimateAckLength = 2;
        }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public override bool Parse(byte[] recvDataArray, int recvLength)
        {
            try
            {
                Ack1 = recvDataArray[0];
                Ack2 = recvDataArray[1];
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
