﻿using PH.Bootloader.RS485.PIC32_2.Protocol.Command.BootCode;

namespace PH.Bootloader.RS485.PIC32_2.Protocol.Command
{
    /// <summary>更新完成確認之指令類別。</summary>
    class VerifyCmd : BootCommandFormatter
    {
        /// <summary>更新完成確認回傳代碼。</summary>
        public static byte  ACK = 0x56;

        /// <summary>取得回傳值。</summary>
        public byte         Ack { get; internal set; }

        /// <summary>初始化 VerifyCmd 類別之執行個體。</summary>
        public VerifyCmd()
        {
            Code = 0x56;
        }

        /// <summary>解析封包格式內容。</summary>
        /// <param name="recvDataArray">接收資料暫存器。</param>
        /// <param name="recvLength">接收資料長度。</param>
        /// <returns>是否解析成功。</returns>
        public override bool Parse(byte[] recvDataArray, int recvLength)
        {
            try
            {
                Ack = recvDataArray[0];
                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
