﻿
namespace PH.Bootloader.RS485.PIC32_2
{
    /// <summary>列舉所有啟動程序安裝結果。</summary>
    public enum UpgradeStatusType : int
    {
        /// <summary>通訊埠尚未備妥。</summary>
        SerialPortNotReady      = 0,
        /// <summary>觸發裝置完成。</summary>
        TriggerFinished         = 10,
        /// <summary>觸發裝置無回應。</summary>
        TriggerNoResponse,
        /// <summary>觸發裝置回應錯誤。</summary>
        TriggerInvalidResponse,
        /// <summary>觸發裝置失敗。</summary>
        TriggerFailed,
        /// <summary>映像檔備妥。</summary>
        ImageFileReady          = 20,
        /// <summary>不合適的映像檔。</summary>
        ImageFileNotAppCode,
        /// <summary>映像檔不存在。</summary>
        ImageFileNotExist,
        /// <summary>映像檔跟裝置不匹配。</summary>
        ImageFileNotMatch,
        /// <summary>映像檔無內容。</summary>
        ImageFileEmpty,
        /// <summary>記憶體配置完成。</summary>
        MemoryAllocated         = 30,
        /// <summary>記憶體尚未配置。</summary>
        MemoryNotAllocated,
        /// <summary>記憶體配置失敗。</summary>
        MemoryAllocationFailed,
        /// <summary>記憶體 CRC 錯誤。</summary>
        MemoryInvalidCRC,
        /// <summary>記憶體抹除中。</summary>
        FlashErasing            = 40,
        /// <summary>記憶體抹除完成。</summary>
        EraseFlashFinished,
        /// <summary>記憶體抹除指令失敗。</summary>
        EraseFlashCommandFailed,
        /// <summary>記憶體抹除大小錯誤。</summary>
        EraseFlashSizeError,
        /// <summary>記憶體抹除失敗。</summary>
        EraseFlashFailed,
        /// <summary>更新中。</summary>
        Upgrading               = 50,
        /// <summary>更新完成。</summary>
        UpgradeFinished,
        /// <summary>更新無效的位址。</summary>
        UpgradeInvalidAddress,
        /// <summary>更新時未得到回應。</summary>
        UpgradeNoResponse,
        /// <summary>更新得到未定義的回應。</summary>
        UpgradeResponseUndefine,
        /// <summary>更新失敗。</summary>
        UpgradeFailed,
        /// <summary>記憶體搬移中。</summary>
        MemoryCopying           = 60,
        /// <summary>記憶體搬移完成。</summary>
        MemoryCopyFinished,
        /// <summary>記憶體搬移失敗。</summary>
        MemoryCopyCommandFailed,
        /// <summary>記憶體沒有頁數。</summary>
        MemoryCopyEmptyPage,
        /// <summary>記憶體搬移沒收到結束命令。</summary>
        MemoryCopyNotDone,
        /// <summary>記憶體搬移大小錯誤。</summary>
        MemoryCopySizeErorr,
        /// <summary>記憶體無完成確認。</summary>
        MemoryCopyNoVerified,
        /// <summary>程式碼確認無回應。</summary>
        VerifyNoResponse        = 70,
        /// <summary>程式碼確認失敗。</summary>
        VerifyCommandFailed,
        /// <summary>程式碼確認完成。</summary>
        VerifyFinished,
        /// <summary>有其他程序執行中。</summary>
        HasOthersProcessRunning = 80
    }
}
