using PhihongEv.Lib.Model;
using System.Linq;

namespace PhihongEv.Lib.Convert
{
    public static class ConnectorTypeConvert
    {
        public static ConnectorTypeCategory ToCategory(this ConnectorType from)
        {
            if (from == null ||
                string.IsNullOrEmpty(from.Code) ||
                from.Code.Length != 1)
            {
                return ConnectorTypeCategory.Unknown;
            }
            
            switch (from.Code[0])
            {
                case '0':
                    return ConnectorTypeCategory.None;
                case '1':
                case '8':
                    return ConnectorTypeCategory.AC;
                case 'J':
                case 'K':
                    return ConnectorTypeCategory.CHadeMO;
                case 'U':
                case 'V':
                case 'T':
                case 'N':
                case 'R':
                    return ConnectorTypeCategory.CCS1;
                case 'E':
                case 'F':
                case 'D':
                case 'M':
                case 'P':
                    return ConnectorTypeCategory.CCS2;
                case 'G':
                    return ConnectorTypeCategory.GBT;
                case 'C':
                    return ConnectorTypeCategory.ChaoJi;
                case 'W':
                    return ConnectorTypeCategory.Wireless;
                default:
                    return ConnectorTypeCategory.Unknown;
            }
        }

        public static ConnectorType ToConnectorType(this string from)
        {
            return ConnectorType.List.FirstOrDefault(x => x.Code == from);
        }
    }
}