using PhihongEv.Lib.Model;
using System.Collections.Generic;
using System.Linq;

namespace PhihongEv.Lib.Convert
{
    public static class MajorTypeConvert
    {
        public static MajorTypeCategory ToCategory(this MajorType from)
        {
            if (from == null ||
                string.IsNullOrEmpty(from.Code))
            {
                return MajorTypeCategory.Unknown;
            }

            if (from.Code.StartsWith("A"))
            {
                return MajorTypeCategory.AC;
            }

            if (from.Code.StartsWith("D"))
            {
                return MajorTypeCategory.DC;
            }

            return MajorTypeCategory.Unknown;
        }

        public static MajorType ToMajorType(this string from)
        {
            return MajorType.List.FirstOrDefault(x => x.Code == from);
        }

        public static string ToCode(this MajorType from) => from.Code;

        public static string ToInfo(this MajorType from) => from.Description;
    }
}