﻿using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace PhihongEv.Lib.Model
{
    public enum ConnectorTypeCategory
    {
        Unknown, None, CHadeMO, CCS1, CCS2, GBT, AC, ChaoJi, Wireless, Type1, Type2
    }

    public sealed partial class ConnectorType : ModelNameCodeModel
    {
        public static ConnectorType Unknown = new ConnectorType("Unknown", "Unknown", addRegister: false);

        public static ConnectorType None = new ConnectorType("0", "None");

        public static ConnectorType N1 = new ConnectorType("1", "IEC 62196-2 Type 1/SAE J1772 Plug)");

        public static ConnectorType N2 = new ConnectorType("2", "IEC 62196-2 Type 1/SAE J1772 Socket");

        public static ConnectorType N3 = new ConnectorType("3", "IEC 62196-2 Type 2 Plug");

        public static ConnectorType N4 = new ConnectorType("4", "IEC 62196-2 Type 2 Socket");

        public static ConnectorType N5 = new ConnectorType("5", "GB/T AC Plug");

        public static ConnectorType N6 = new ConnectorType("6", "GB/T AC Socket");

        public static ConnectorType N7 = new ConnectorType("7", "CCS2 AC Plug");

        public static ConnectorType N8 = new ConnectorType("8", "Type E socket");

        public static ConnectorType J = new ConnectorType("J", "CHAdeMO 125A");

        public static ConnectorType U = new ConnectorType("U", "CCS1 200A");

        public static ConnectorType V = new ConnectorType("V", "Liquid cooling CCS1 500A");

        public static ConnectorType E = new ConnectorType("E", "CCS2 200A");

        public static ConnectorType F = new ConnectorType("F", "Liquid cooling CCS2 500A");

        public static ConnectorType G = new ConnectorType("G", "GBT DC");

        public static ConnectorType T = new ConnectorType("T", "CCS1 300A");

        public static ConnectorType D = new ConnectorType("D", "CCS2 300A");

        public static ConnectorType K = new ConnectorType("K", "CHadeMO 200A");

        public static ConnectorType M = new ConnectorType("M", "CCS2 80A");

        public static ConnectorType N = new ConnectorType("N", "CCS1 80A");

        public static ConnectorType P = new ConnectorType("P", "pantograph");

        public static ConnectorType R = new ConnectorType("R", "Phoenix 250A");

        public static ConnectorType C = new ConnectorType("C", "Reserved for ChaoJi");

        public static ConnectorType W = new ConnectorType("W", "Reserved for Wireless");

        public static ConnectorType B = new ConnectorType("B", "GBT YG PT1000");

        public static ConnectorType H = new ConnectorType("H", "WOER GBT 500A");

        public static ConnectorType A = new ConnectorType("A", "WOER GBT 400A");

        public static ConnectorType L = new ConnectorType("L", "CHAdeMO 80A");

        public static ConnectorType Y = new ConnectorType("Y", "CCS1 150A");

        public static ConnectorType Z = new ConnectorType("Z", "CCS2 150A");

        public static ConnectorType S = new ConnectorType("S", "CHAdeMO 125A Boost Mode");

        public static ConnectorType I = new ConnectorType("I", "CCS1 300A Boost mode");

        public static ConnectorType Q = new ConnectorType("Q", "CCS2 300A Boost mode");

        public static ConnectorType O = new ConnectorType("O", "CHA 200A boost 350A");
    }

    public sealed partial class ConnectorType : ModelNameCodeModel
    {
        public static ReadOnlyCollection<ConnectorType> List => new ReadOnlyCollection<ConnectorType>(_List);

        private static List<ConnectorType> _List { get; set; }

        internal ConnectorType(string code, string description, bool addRegister = true) : base(code, description)
        {
            if (_List == null)
            {
                _List = new List<ConnectorType>();
            }

            if (!addRegister)
            {
                return;
            }

            _List.Add(this);
        }
    }
}