﻿using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace PhihongEv.Lib.Model
{
    //public enum InputConfig
    //{
    //    Unknown, Y, D, L, S, W, T, E, N0, N1, N2, N3, N4, N5, N6, N7, N8, N9, NA
    //}

    public sealed partial class InputConfig : ModelNameCodeModel
    {
        public static InputConfig Unknown = new InputConfig("Unknown", "Unknown", addRegister: false);

        public static InputConfig Y = new InputConfig("Y", "3 phase wyi-connection 4 wires + PE, 380 - 415Vac, 50Hz/60Hz");

        public static InputConfig D = new InputConfig("D", "3 phase delta-connection 3 wires + PE, 200 - 240Vac, 50Hz/60Hz");

        public static InputConfig L = new InputConfig("L", "2 phase 2 wires + PE, 200 - 240Vac, 50Hz/60Hz");

        public static InputConfig S = new InputConfig("S", "1 phase 2 wires + PE, 220 - 240Vac, 50Hz/60Hz");

        public static InputConfig W = new InputConfig("W", "3 phase wyi-connection 4 wires + PE, 380 - 480Vac, 50Hz/60Hz");

        public static InputConfig T = new InputConfig("T", "1 phase 2 wires + PE, 220 - 277Vac, 50Hz/60Hz");

        public static InputConfig E = new InputConfig("E", "1 Phase 2 wires + PE, 100 - 120Vac, 50Hz/60Hz");

        public static InputConfig N0 = new InputConfig("0", "1 phase 2 wires + PE, CEE 7/7 plug (compatible with Type E and Type F), 220 - 240Vac, 50Hz/60Hz. (For European)");

        public static InputConfig N1 = new InputConfig("1", "1 phase 2 wires + PE, BS 1363 plug (Type G), 220 - 240Vac, 50Hz/60Hz. (For UK)");

        public static InputConfig N2 = new InputConfig("2", "1 phase 2 wires + PE, AS/NZS 3112 (Type I), 220 - 240Vac, 50Hz/60Hz. (For Australia, New Zealand)");

        public static InputConfig N3 = new InputConfig("3", "1 phase 2 wires + PE, GB 2099.1‐2008 and GB 1002‐2008 (Type I), 220 - 240Vac, 50Hz/60Hz. (For China)");

        public static InputConfig N4 = new InputConfig("4", "1 phase 2 wires + PE, IS1293 plug (Type M), 220 - 240Vac, 50Hz/60Hz. (For Indian and South African)");

        public static InputConfig N5 = new InputConfig("5", "2 phase 2 wires + PE, NEMA 5-15 plug (Type B), 120 Vac, 50Hz/60Hz.(For UL, TW, Japan)");

        public static InputConfig N6 = new InputConfig("6", "2 phase 2 wires + PE, NEMA 6-20 plug, 200 - 240Vac, 50Hz/60Hz. (For UL, TW)");

        public static InputConfig N7 = new InputConfig("7", "2 phase 2 wires + PE, NEMA 14-30 plug, 120 - 240Vac, 50Hz/60Hz. (For UL)");

        public static InputConfig N8 = new InputConfig("8", "2 phase 2 wires + PE, NEMA 14-50 plug, 120 - 240Vac, 50Hz/60Hz. (For UL)");

        public static InputConfig N9 = new InputConfig("9", "2 phase 2 wires + PE, NEMA 6-50 plug, 200 - 240Vac, 50Hz/60Hz. (For UL, TW)");

        public static InputConfig A = new InputConfig("A", "2 phase 2 wires + PE, NEMA 14-60 plug, 200 - 240Vac, 50Hz/60Hz. (For UL)");
    }

    public sealed partial class InputConfig : ModelNameCodeModel
    {
        public static ReadOnlyCollection<InputConfig> List => new ReadOnlyCollection<InputConfig>(_List);

        private static List<InputConfig> _List { get; set; }

        internal InputConfig(string code, string description, bool addRegister = true) : base(code, description)
        {

            if (_List == null)
            {
                _List = new List<InputConfig>();
            }

            if (!addRegister)
            {
                return;
            }

            _List.Add(this);
        }
    }
}