using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace PhihongEv.Lib.Model
{
    public enum MajorTypeCategory
    {
        Unknown,
        AC,
        DC,
        Hybrid
    }

    //public enum MajorType
    //{
    //    Unknown,AC,AW,AP,AX,DW,DS,DM,DR,DD,DO,DQ,DK,DX,DB
    //}

    public sealed partial class MajorType : ModelNameCodeModel
    {
        public static readonly MajorType Unknown = new MajorType("Unknown", "Unknown", addRegister:false);

        public static readonly MajorType AC = new MajorType("AC", "Ac EVse Cordset");

        public static readonly MajorType AW = new MajorType("AW", "Ac EVse Wallmount");

        public static readonly MajorType AP = new MajorType("AP", "Ac EVse Pedestal");

        public static readonly MajorType AX = new MajorType("AX", "Ac EVse Wallmount excellent type");

        public static readonly MajorType DW = new MajorType("DW", "Dc EVse Wallmount");

        public static readonly MajorType DS = new MajorType("DS", "Dc EVse Standalone");

        public static readonly MajorType DM = new MajorType("DM", "Dc EVse Moveable");

        public static readonly MajorType DR = new MajorType("DR", "Dc EVse Power Rack (without cabinet)");

        public static readonly MajorType DD = new MajorType("DD", "Dc EVse Dispenser");

        public static readonly MajorType DO = new MajorType("DO", "Dc EVse Output power cabinet");

        public static readonly MajorType DQ = new MajorType("DQ", "Dc EVse infy 30KW GB module");

        public static readonly MajorType DK = new MajorType("DK", "Dc EVse Power Rack");

        public static readonly MajorType DX = new MajorType("DX", "Dc EVse Output Communication Box (Dispenser)");

        public static readonly MajorType DB = new MajorType("DB", "Dc to Dc EVSE Output power cabinet");

        public static readonly MajorType DH = new MajorType("DH", "Simplified CSU3.0");

        public static readonly MajorType DL = new MajorType("DL", "DC EVse Liquid cooling Power Cabinet");
    }

    public sealed partial class MajorType : ModelNameCodeModel
    {
        public static ReadOnlyCollection<MajorType> List => new ReadOnlyCollection<MajorType>(_List);

        private static List<MajorType> _List { get; set; }

        internal MajorType(string code, string description, bool addRegister = true) : base(code, description)
        {
            if (_List == null)
            {
                _List = new List<MajorType>();
            }

            if (!addRegister)
            {
                return;
            }

            _List.Add(this);
        }
    }
}