using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace PhihongEv.Lib.Model
{
    //public enum SafetyRegulation
    //{
    //    Unknown,
    //    CE_Europoean,
    //    UL_NorthAmerica,
    //    GB_China,
    //    CNS_Taiwan,
    //    JARI_Japan,
    //    TR25_Singapor,
    //    KC_Korea,
    //    British_UK,
    //    EVready_French,
    //    M,
    //    P,
    //    I,
    //    F,
    //    L
    //}

    public sealed partial class SafetyRegulation : ModelNameCodeModel
    {
        public static SafetyRegulation Unknown = new SafetyRegulation("Unknown", "Unknown", addRegister: false);

        public static SafetyRegulation E = new SafetyRegulation("E", "CE / European Market");

        public static SafetyRegulation U = new SafetyRegulation("U", "UL / North America Market");

        public static SafetyRegulation G = new SafetyRegulation("G", "GB / China Market");

        public static SafetyRegulation C = new SafetyRegulation("C", "CNS / Taiwan Market");

        public static SafetyRegulation J = new SafetyRegulation("J", "JARI / Japan Market");

        public static SafetyRegulation T = new SafetyRegulation("T", "TR25 / Singapor Market");

        public static SafetyRegulation K = new SafetyRegulation("K", "KC / Korea Market");

        public static SafetyRegulation B = new SafetyRegulation("B", "British / UK Market");

        public static SafetyRegulation Z = new SafetyRegulation("Z", "EV ready / French Market");

        public static SafetyRegulation M = new SafetyRegulation("M", "E + MID Meter");

        public static SafetyRegulation P = new SafetyRegulation("P", "E + PTB certification");

        public static SafetyRegulation I = new SafetyRegulation("I", "Z + TIC Meter pcb");

        public static SafetyRegulation F = new SafetyRegulation("F", "Z + MID Meter");

        public static SafetyRegulation L = new SafetyRegulation("L", "U + UL meter");

        public static SafetyRegulation W = new SafetyRegulation("W", "CNS / Taiwan Manufacture");
    }

    public sealed partial class SafetyRegulation : ModelNameCodeModel
    {
        public static ReadOnlyCollection<SafetyRegulation> List => new ReadOnlyCollection<SafetyRegulation>(_List);

        private static List<SafetyRegulation> _List { get; set; }

        internal SafetyRegulation(string code, string description, bool addRegister = true) : base(code, description)
        {

            if (_List == null)
            {
                _List = new List<SafetyRegulation>();
            }

            if (!addRegister)
            {
                return;
            }

            _List.Add(this);
        }
    }
}