﻿
namespace FirmwareHeaderBuilder.Model
{
    /// <summary>列舉所有錯誤碼。</summary>
    enum ErrorCode : byte
    {
        /// <summary>沒有錯誤。</summary>
        NoError,
        /// <summary>無檔案路徑。</summary>
        FilePathEmpty,
        /// <summary>檔案不存在。</summary>
        FileNotExist,
        /// <summary>讀取檔案發生錯誤。</summary>
        ReadFileError,
        /// <summary>產品型號不存在。</summary>
        ModelNameEmpty,
        /// <summary>產品型號超過長度限制。</summary>
        ModelNameLenError,
        /// <summary>產品型號輸入型態錯誤。</summary>
        ModelNameInputTypeError,
        /// <summary>產品型號尚未備妥。</summary>
        ModelNameNotReady,
        /// <summary>映像檔索引不存在。</summary>
        ImageTypeIndexNotExist,
        /// <summary>映像檔資料尚未備妥。</summary>
        ImageDataNotReady,
        /// <summary>記憶體配置錯誤。</summary>
        MemoryAllocationError,
        /// <summary>創建檔案時發生錯誤。</summary>
        BuiltFileError,
        /// <summary>創建完成。</summary>
        BuiltSuccess,
    }
}
