﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FirmwareHeaderBuilder.Model.ModelNaming
{
    public class RatedPower
    {
        public static RatedPower R190 = new RatedPower("190", "1.9 kW (AC 120V with 16A)");

        public static RatedPower R380 = new RatedPower("380", "3.8 kW (AC 120V with 32A)");

        public static RatedPower R350 = new RatedPower("350", "3.5 kW (AC 220V with 16A)");

        public static RatedPower R700 = new RatedPower("700", "7kW (AC 220V with 32A)");

        public static RatedPower R251 = new RatedPower("251", "25kW");

        public static RatedPower R301 = new RatedPower("301", "30kW");

        public static RatedPower R362 = new RatedPower("360", "360kW");

        /// <summary>取得代碼。</summary>
        public string Code { get; set; }
        /// <summary>取得名稱。</summary>
        public string Name { get; set; }

        /// <summary>初始化 RatedPower 類別的新執行個體。</summary>
        /// <param name="code"></param>
        /// <param name="name"></param>
        public RatedPower(string code, string name)
        {
            Code = code;
            Name = name;
        }

        public static IEnumerable<RatedPower> List
        {
            get
            {
                yield return R190;
                yield return R380;
                yield return R350;
                yield return R700;
                yield return R251;
                yield return R301;
                yield return R362;
            }
        }

        public static IEnumerable<string> ListName
        {
            get
            {
                yield return R190.Name;
                yield return R380.Name;
                yield return R350.Name;
                yield return R700.Name;
                yield return R251.Name;
                yield return R301.Name;
                yield return R362.Name;
            }
        }

        public static RatedPower Parse(string name)
        {
            foreach (var item in List)
            {
                if (string.Equals(name, item.Name))
                {
                    return item;
                }
            }

            return null;
        }

        public static RatedPower ParseByCode(string code)
        {
            foreach (var item in List)
            {
                if (string.Equals(code, item.Code))
                {
                    return item;
                }
            }

            return null;
        }
    }
}
